/*
 * Copyright 2022 Red Hat, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.playground.interceptors;

import java.util.Map;

import javax.interceptor.AroundInvoke;
import javax.interceptor.InvocationContext;

import org.jboss.logging.Logger;
import org.jboss.playground.token.SimpleToken;

public class EjbContainerInterceptor {

    Logger logger = Logger.getLogger(EjbContainerInterceptor.class);

    @AroundInvoke
    public Object aroundInvoke(final InvocationContext invocationContext) throws Exception {
        Map<String, Object> contextData = invocationContext.getContextData();
        logger.infof("contextData %s", contextData);
        
//        contextData.put("ModifyKey", "ModifyKeyServerValue");
//        contextData.put("ServerKey", "ServerKeyAddedValue");

        //        contextData.put("ModifyKey", new SimpleToken("ServerSideSetValue"));
//        contextData.put("ServerKey", new SimpleToken("This is a new server side added key"));

        Object returnObject;

        try {
            returnObject = invocationContext.proceed();
            return returnObject;

        } finally {
            contextData.remove("DeleteKey");
            contextData.remove("AnyKey");
        }
    }
}
