/*
 * Copyright 2022 Red Hat, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.playground.client.interceptor;

import org.jboss.ejb.client.EJBClientInterceptor;
import org.jboss.ejb.client.EJBClientInvocationContext;
import org.jboss.logging.Logger;

public class PlaygroundEjbClientSideInterceptor implements EJBClientInterceptor {

    Logger logger = Logger.getLogger(PlaygroundEjbClientSideInterceptor.class);
    
    public void handleInvocation(EJBClientInvocationContext context) throws Exception {
        
        // not adding ClientKey, keep the value we set here...
//        context.addReturnedContextDataKey("ModifyKey");
//        context.addReturnedContextDataKey("DeleteKey");
//        context.addReturnedContextDataKey("ServerKey");
//
//        context.getContextData().put("ClientKey", "ClientKeyValue");
//        context.getContextData().put("ModifyKey", "ModifyKeyClientValue");
//        context.getContextData().put("DeleteKey", "DeleteKeyValue");

        context.addReturnedContextDataKey("AnyKey");
        context.getContextData().put("AnyKey", "ClientValueForAnyKey");

        
        logger.warnf("ContextData: %s", context.getContextData());

        context.sendRequest();
    }

    public Object handleInvocationResult(EJBClientInvocationContext context) throws Exception {
        try {
            return context.getResult();
        } finally {
            logger.warnf("Returned context data: %s", context.getContextData());
        }
    }

}
