#!/bin/bash

if [ "x$JBOSS_HOME" == "x" ]; then
	echo "\$JBOSS_HOME must be set"
	exit 0
fi

VERSION=`cat ${JBOSS_HOME}/version.txt | sed -e 's/^.*Version //g'`

JBOSS_HOME_CLIENT_DIR="$JBOSS_HOME/bin/client"
JBOSS_CLIENT_JAR="$JBOSS_HOME_CLIENT_DIR/jboss-client.jar"
JBOSS_CLI_CLIENT_JAR="$JBOSS_HOME_CLIENT_DIR/jboss-cli-client.jar"

if [ ! -f "$JBOSS_CLIENT_JAR" ]; then
	echo "'jboss-client.jar' not present at '$JBOSS_HOME_CLIENT_DIR'"
	exit 0
fi

if [ ! -f "$JBOSS_CLI_CLIENT_JAR" ]; then
	echo "'jboss-cli-client.jar' not present at '$JBOSS_HOME_CLIENT_DIR'"
	exit 0
fi

read -n1 -p "Install JBoss EJB client API into the local Maven repository for JBoss EAP ${VERSION}? [y,n] " doit 
case $doit in  
  y|Y) 
	mvn install:install-file -DgroupId=org.jboss -DartifactId=jboss-client-jar-local -Dversion=${VERSION} -Dpackaging=jar -Dfile=$JBOSS_HOME/bin/client/jboss-client.jar
	mvn install:install-file -DgroupId=org.jboss -DartifactId=jboss-cli-client-jar-local -Dversion=${VERSION} -Dpackaging=jar -Dfile=$JBOSS_HOME/bin/client/jboss-cli-client.jar
	;;
  *)
	echo ""
	exit 0;;
esac

